2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
5 ## Copyright (C) 2001-2009 Free Software Foundation, Inc.
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 ## GNU General Public License for more details.
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program. If not, see <http://www.gnu.org/licenses/>.
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
24 # Override this in cfg.mk if you use a non-standard build-aux directory.
25 build_aux ?
= $(srcdir)/build-aux
27 # Do not save the original name or timestamp in the .tar.gz file.
28 # Use --rsyncable if available.
30 $(shell gzip
--help
2>/dev
/null|grep rsyncable
>/dev
/null
&& echo
--rsyncable
)
31 GZIP_ENV
= '--no-name --best $(gzip_rsyncable)'
33 # cfg.mk must define the gpg_key_ID used by this package.
36 VC-tag
= git tag
-s
-m
'$(VERSION)' -u
'$(gpg_key_ID)'
38 VC_LIST
= $(build_aux
)/vc-list-files
-C
$(srcdir)
41 $(VC_LIST
) | if
test -f
$(srcdir)/.x-
$@
; then grep
-vEf
$(srcdir)/.x-
$@
; \
42 else grep
-Ev
"$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi
44 ifeq ($(origin prev_version_file
), undefined
)
45 prev_version_file
= $(srcdir)/.prev-version
48 PREV_VERSION
:= $(shell cat
$(prev_version_file
) 2>/dev
/null
)
49 VERSION_REGEXP
= $(subst .
,\.
,$(VERSION
))
50 PREV_VERSION_REGEXP
= $(subst .
,\.
,$(PREV_VERSION
))
53 this-vc-tag
= v
$(VERSION
)
54 this-vc-tag-regexp
= v
$(VERSION_REGEXP
)
56 tag-package
= $(shell echo
"$(PACKAGE)" | tr
'[:lower:]' '[:upper:]')
57 tag-this-version
= $(subst .
,_
,$(VERSION
))
58 this-vc-tag
= $(tag-package
)-$(tag-this-version
)
59 this-vc-tag-regexp
= $(this-vc-tag
)
61 my_distdir
= $(PACKAGE
)-$(VERSION
)
63 # Old releases are stored here.
64 release_archive_dir ?
= ..
/release
66 # Prevent programs like 'sort' from considering distinct strings to be equal.
67 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
74 _cfg_mk
:= $(shell test -f
$(srcdir)/cfg.mk
&& echo
'$(srcdir)/cfg.mk')
76 # Collect the names of rules starting with `sc_'.
77 syntax-check-rules
:= $(sort $(shell sed
-n
's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
78 $(srcdir)/$(ME
) $(_cfg_mk
)))
79 .PHONY
: $(syntax-check-rules
)
81 local-checks-available
= \
83 .PHONY
: $(local-checks-available
)
85 # Arrange to print the name of each syntax-checking rule just before running it.
86 $(syntax-check-rules
): %: %.m
87 $(patsubst %, %.m
, $(syntax-check-rules
)):
88 @echo
$(patsubst sc_
%.m
, %, $@
)
90 local-check
:= $(filter-out $(local-checks-to-skip
), $(local-checks-available
))
92 syntax-check
: $(local-check
)
93 # @grep -nE '# *include <(limits|std(def|arg|bool))\.h>' \
94 # $$(find -type f -name '*.[chly]') && \
95 # { echo '$(ME): found conditional include' 1>&2; \
98 # grep -nE '^# *include <(string|stdlib)\.h>' \
99 # $(srcdir)/{lib,src}/*.[chy] && \
100 # { echo '$(ME): FIXME' 1>&2; \
102 # FIXME: don't allow `#include .strings\.h' anywhere
104 # By default, _prohibit_regexp does not ignore case.
106 _ignore_case
= $$(test -n
"$$ignore_case" && echo
-i ||
:)
108 # There are many rules below that prohibit constructs in this package.
109 # If the offending construct can be matched with a grep-E-style regexp,
110 # use this macro. The shell variables "re" and "msg" must be defined.
111 define _prohibit_regexp
112 dummy
=; : so we do not need a semicolon before each use
; \
113 test "x$$re" != x ||
{ echo
'$(ME): re not defined' 1>&2; exit
1; }; \
114 test "x$$msg" != x ||
{ echo
'$(ME): msg not defined' 1>&2; exit
1; };\
115 grep
$(_ignore_case
) -nE
"$$re" $$($(VC_LIST_EXCEPT
)) && \
116 { echo
'$(ME): '"$$msg" 1>&2; exit
1; } ||
:
119 sc_avoid_if_before_free
:
120 @
$(build_aux
)/useless-if-before-free \
121 $(useless_free_options
) \
122 $$($(VC_LIST_EXCEPT
) | grep
-v useless-if-before-free
) && \
123 { echo
'$(ME): found useless "if" before "free" above' 1>&2; \
126 sc_cast_of_argument_to_free
:
127 @re
='\<free *\( *\(' msg
='don'\''t cast free argument' \
130 sc_cast_of_x_alloc_return_value
:
131 @re
='\*\) *x(m|c|re)alloc\>' \
132 msg
='don'\''t cast x*alloc return value' \
135 sc_cast_of_alloca_return_value
:
136 @re
='\*\) *alloca\>' msg
='don'\''t cast alloca return value' \
140 @re
='[ ] ' msg
='found SPACE-TAB sequence; remove the SPACE' \
143 # Don't use *scanf or the old ato* functions in `real' code.
144 # They provide no error checking mechanism.
145 # Instead, use strto* functions.
146 sc_prohibit_atoi_atof
:
147 @re
='\<([fs]?scanf|ato([filq]|ll)) *\(' \
148 msg
='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
151 # Use STREQ rather than comparing strcmp == 0, or != 0.
153 @grep
-nE
'! *str''cmp *\(|\<str''cmp *\([^)]+\) *==' \
154 $$($(VC_LIST_EXCEPT
)) \
155 | grep
-vE
':# *define STREQ\(' && \
156 { echo
'$(ME): use STREQ in place of the above uses of str''cmp' \
159 # Using EXIT_SUCCESS as the first argument to error is misleading,
160 # since when that parameter is 0, error does not exit. Use `0' instead.
161 sc_error_exit_success
:
162 @grep
-nE
'error \(EXIT_SUCCESS,' \
163 $$($(VC_LIST_EXCEPT
) | grep
-E
'\.[chly]$$') && \
164 { echo
'$(ME): found error (EXIT_SUCCESS' 1>&2; exit
1; } ||
:
166 # `FATAL:' should be fully upper-cased in error messages
167 # `WARNING:' should be fully upper-cased, or fully lower-cased
168 sc_error_message_warn_fatal
:
169 @grep
-nEA2
'[^rp]error \(' $$($(VC_LIST_EXCEPT
)) \
170 | grep
-E
'"Warning|"Fatal|"fatal' && \
171 { echo
'$(ME): use FATAL, WARNING or warning' 1>&2; \
174 # Error messages should not start with a capital letter
175 sc_error_message_uppercase
:
176 @grep
-nEA2
'[^rp]error \(' $$($(VC_LIST_EXCEPT
)) \
178 | grep
-vE
'"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
179 { echo
'$(ME): found capitalized error message' 1>&2; \
182 # Error messages should not end with a period
183 sc_error_message_period
:
184 @grep
-nEA2
'[^rp]error \(' $$($(VC_LIST_EXCEPT
)) \
185 | grep
-E
'[^."]\."' && \
186 { echo
'$(ME): found error message ending in period' 1>&2; \
190 @re
=file
''system ignore_case
=1 \
191 msg
='found use of "file''system"; spell it "file system"' \
194 # Don't use cpp tests of this symbol. All code assumes config.h is included.
195 sc_prohibit_have_config_h
:
196 @grep
-n
'^# *if.*HAVE''_CONFIG_H' $$($(VC_LIST_EXCEPT
)) && \
197 { echo
'$(ME): found use of HAVE''_CONFIG_H; remove' \
200 # Nearly all .c files must include <config.h>. However, we also permit this
201 # via inclusion of a package-specific header, if cfg.mk specified one.
202 # config_h_header must be suitable for grep -E.
203 config_h_header ?
= <config\.h
>
205 @if
$(VC_LIST_EXCEPT
) | grep
-l
'\.c$$' > /dev
/null
; then \
206 grep
-EL
'^# *include $(config_h_header)' \
207 $$($(VC_LIST_EXCEPT
) | grep
'\.c$$') \
209 { echo
'$(ME): the above files do not include <config.h>' \
210 1>&2; exit
1; } ||
:; \
214 # You must include <config.h> before including any other header file.
215 # This can possibly be via a package-specific header, if given by cfg.mk.
216 sc_require_config_h_first
:
217 @if
$(VC_LIST_EXCEPT
) | grep
-l
'\.c$$' > /dev
/null
; then \
219 for i in
$$($(VC_LIST_EXCEPT
) | grep
'\.c$$'); do \
220 grep
'^# *include\>' $$i | sed
1q \
221 | grep
-E
'^# *include $(config_h_header)' > /dev
/null \
222 ||
{ echo
$$i; fail
=1; }; \
225 { echo
'$(ME): the above files include some other header' \
226 'before <config.h>' 1>&2; exit
1; } ||
:; \
230 sc_prohibit_HAVE_MBRTOWC
:
231 @re
='\bHAVE_MBRTOWC\b' msg
="do not use $$re; it is always defined" \
234 # To use this "command" macro, you must first define two shell variables:
235 # h: the header, enclosed in <> or ""
236 # re: a regular expression that matches IFF something provided by $h is used.
237 define _header_without_use
238 dummy
=; : so we do not need a semicolon before each use
; \
239 h_esc
=`echo "$$h"|sed 's/\./\\\\./g'`; \
240 if
$(VC_LIST_EXCEPT
) | grep
-l
'\.c$$' > /dev
/null
; then \
241 files
=$$(grep
-l
'^# *include '"$$h_esc" \
242 $$($(VC_LIST_EXCEPT
) | grep
'\.c$$')) && \
243 grep
-LE
"$$re" $$files | grep .
&& \
244 { echo
"$(ME): the above files include $$h but don't use it" \
245 1>&2; exit
1; } ||
:; \
250 # Prohibit the inclusion of assert.h without an actual use of assert.
251 sc_prohibit_assert_without_use
:
252 @h
='<assert.h>' re
='\<assert *\(' $(_header_without_use
)
254 # Prohibit the inclusion of getopt.h without an actual use.
255 sc_prohibit_getopt_without_use
:
256 @h
='<getopt.h>' re
='\<getopt(_long)? *\(' $(_header_without_use
)
258 # Don't include quotearg.h unless you use one of its functions.
259 sc_prohibit_quotearg_without_use
:
260 @h
='"quotearg.h"' re
='\<quotearg(_[^ ]+)? *\(' $(_header_without_use
)
262 # Don't include quote.h unless you use one of its functions.
263 sc_prohibit_quote_without_use
:
264 @h
='"quote.h"' re
='\<quote(_n)? *\(' $(_header_without_use
)
266 # Don't include this header unless you use one of its functions.
267 sc_prohibit_long_options_without_use
:
268 @h
='"long-options.h"' re
='\<parse_long_options *\(' \
269 $(_header_without_use
)
271 # Don't include this header unless you use one of its functions.
272 sc_prohibit_inttostr_without_use
:
273 @h
='"inttostr.h"' re
='\<(off|[iu]max|uint)tostr *\(' \
274 $(_header_without_use
)
276 # Don't include this header unless you use one of its functions.
277 sc_prohibit_error_without_use
:
279 re
='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
280 $(_header_without_use
)
282 sc_prohibit_safe_read_without_use
:
283 @h
='"safe-read.h"' re
='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
284 $(_header_without_use
)
286 sc_prohibit_argmatch_without_use
:
288 re
='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<argmatch(_exit_fn|_(in)?valid) *\()' \
289 $(_header_without_use
)
291 sc_prohibit_canonicalize_without_use
:
292 @h
='"canonicalize.h"' \
293 re
='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode)' \
294 $(_header_without_use
)
296 sc_prohibit_root_dev_ino_without_use
:
297 @h
='"root-dev-ino.h"' \
298 re
='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
299 $(_header_without_use
)
301 sc_prohibit_openat_without_use
:
303 re
='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
304 $(_header_without_use
)
306 # Prohibit the inclusion of c-ctype.h without an actual use.
307 ctype_re
= isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
308 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
309 sc_prohibit_c_ctype_without_use
:
310 @h
='[<"]c-ctype.h[">]' re
='\<c_($(ctype_re)) *\(' $(_header_without_use
)
313 _sp
= $(_empty
) $(_empty
)
314 # The following list was generated by running:
315 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
316 # | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
318 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
319 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
320 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
321 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
322 _sig_function_re
= $(subst $(_sp
),|
,$(strip $(_sig_functions
)))
323 # The following were extracted from "man signal.h" manually.
324 _sig_types_and_consts
= \
325 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
326 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
327 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
328 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
329 sigstack sigval stack_t ucontext_t
330 # generated via this:
331 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
333 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
334 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
335 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
336 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
337 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
338 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
339 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
341 _sig_syms_re
= $(subst $(_sp
),|
,$(strip $(_sig_names
) $(_sig_types_and_consts
)))
343 # Prohibit the inclusion of signal.h without an actual use.
344 sc_prohibit_signal_without_use
:
346 re
='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
347 $(_header_without_use
)
350 @re
='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
351 msg
='do not use HAVE''_FCNTL_H or O'_NDELAY \
354 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
356 # Each nonempty ChangeLog line must start with a year number, or a TAB.
358 @if
$(VC_LIST_EXCEPT
) | grep
-l
'^ChangeLog$$' >/dev
/null
; then \
360 $$($(VC_LIST_EXCEPT
) | grep
'^ChangeLog$$') && \
361 { echo
'$(ME): found unexpected prefix in a ChangeLog' 1>&2; \
365 # Ensure that each .c file containing a "main" function also
366 # calls set_program_name.
368 @if
$(VC_LIST_EXCEPT
) | grep
-l
'\.c$$' > /dev
/null
; then \
369 files
=$$(grep
-l
'^main *(' $$($(VC_LIST_EXCEPT
) | grep
'\.c$$')); \
370 grep
-LE
'set_program_name *\(m?argv\[0\]\);' $$files \
372 { echo
'$(ME): the above files do not call set_program_name' \
373 1>&2; exit
1; } ||
:; \
377 # Require that the final line of each test-lib.sh-using test be this one:
379 # Note: this test requires GNU grep's --label= option.
380 Exit_witness_file ?
= tests
/test-lib.sh
381 Exit_base
:= $(notdir $(Exit_witness_file
))
382 sc_require_test_exit_idiom
:
383 @if
test -f
$(srcdir)/$(Exit_witness_file
); then \
385 for i in
$$(grep
-l
-F
'srcdir/$(Exit_base)' \
386 $$($(VC_LIST
) tests
)); do \
387 tail
-n1
$$i | grep
'^Exit .' > /dev
/null \
388 && : ||
{ die
=1; echo
$$i; } \
391 { echo
1>&2 '$(ME): the final line in each of the above is not:'; \
392 echo
1>&2 'Exit something'; \
397 @re
='\<the ''the\>' \
398 ignore_case
=1 msg
='found use of "the ''the";' \
403 msg
='found trailing blank(s)' \
406 # Match lines like the following, but where there is only one space
407 # between the options and the description:
408 # -D, --all-repeated[=delimit-method] print all duplicate lines\n
409 longopt_re
= --[a-z
][0-9A-Za-z-
]*(\
[?
=[0-9A-Za-z-
]*\
]?
)?
410 sc_two_space_separator_in_usage
:
411 @grep
-nE
'^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
412 $$($(VC_LIST_EXCEPT
)) && \
413 { echo
"$(ME): help2man requires at least two spaces between"; \
414 echo
"$(ME): an option and its description"; \
417 # Look for diagnostics that aren't marked for translation.
418 # This won't find any for which error's format string is on a separate line.
419 sc_unmarked_diagnostics
:
421 '\<error \([^"]*"[^"]*[a-z]{3}' $$($(VC_LIST_EXCEPT
)) \
422 | grep
-v
'_''(' && \
423 { echo
'$(ME): found unmarked diagnostic(s)' 1>&2; \
426 # Avoid useless parentheses like those in this example:
427 # #if defined (SYMBOL) || defined (SYM2)
428 sc_useless_cpp_parens
:
429 @grep
-n
'^# *if .*defined *(' $$($(VC_LIST_EXCEPT
)) && \
430 { echo
'$(ME): found useless parentheses in cpp directive' \
433 # Require the latest GPL.
435 @re
='either ''version [^3]' msg
='GPL vN, N!=3' \
439 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
441 sc_prohibit_cvs_keyword
:
442 @re
='\$$($(cvs_keywords))\$$' \
443 msg
='do not use CVS keyword expansion' \
446 # Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
447 # This is a bit of a kludge, since it prevents use of the string
448 # even in comments, but for now it does the job with no false positives.
449 sc_prohibit_stat_st_blocks
:
450 @re
='[.>]st_blocks' msg
='do not use st_blocks; use ST_NBLOCKS' \
453 # Make sure we don't define any S_IS* macros in src/*.c files.
454 # They're already defined via gnulib's sys/stat.h replacement.
455 sc_prohibit_S_IS_definition
:
456 @re
='^ *# *define *S_IS' \
457 msg
='do not define S_IS* macros; include <sys/stat.h>' \
460 # Each program that uses proper_name_utf8 must link with
461 # one of the ICONV libraries.
462 sc_proper_name_utf8_requires_ICONV
:
463 @progs
=$$(grep
-l
'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT
)));\
464 if
test "x$$progs" != x
; then \
466 for p in
$$progs; do \
467 dir=$$(dirname
"$$p"); \
468 base
=$$(basename "$$p" .c
); \
469 grep
"$${base}_LDADD.*ICONV)" $$dir/Makefile.am
> /dev
/null \
470 ||
{ fail
=1; echo
1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
473 { echo
1>&2 '$(ME): the above do not link with any ICONV library'; \
477 # Warn about "c0nst struct Foo const foo[]",
478 # but not about "char const *const foo" or "#define const const".
480 @re
='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
481 msg
='redundant "const" in declarations' \
484 sc_const_long_option
:
485 @grep
'^ *static.*struct option ' $$($(VC_LIST_EXCEPT
)) \
486 | grep
-Ev
'const struct option|struct option const' && { \
487 echo
1>&2 '$(ME): add "const" to the above declarations'; \
491 $$(sed
-n
'/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
493 | grep
-v
'^Copyright .*Free Software' \
497 # Ensure that we don't accidentally insert an entry into an old NEWS block.
499 @if
test -f
$(srcdir)/NEWS
; then \
500 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
501 { echo
'$(ME): you have modified old NEWS' 1>&2; exit
1; }; \
504 # Update the hash stored above. Do this after each release and
505 # for any corrections to old entries.
506 update-NEWS-hash
: NEWS
507 perl
-pi
-e
's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
510 # Ensure that we use only the standard $(VAR) notation,
511 # not @...@ in Makefile.am, now that we can rely on automake
512 # to emit a definition for each substituted variable.
513 # We use perl rather than "grep -nE ..." to exempt a single
514 # use of an @...@-delimited variable name in src/Makefile.am.
516 @perl
-ne
'/\@[A-Z_0-9]+\@/ && !/^cu_install_program =/' \
517 -e
'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
518 $$($(VC_LIST_EXCEPT
) | grep
-E
'(^|/)Makefile\.am$$') \
519 && { echo
'$(ME): use $$(...), not @...@' 1>&2; exit
1; } ||
:
521 news-date-check
: NEWS
522 today
=`date +%Y-%m-%d`; \
523 if head
$(srcdir)/NEWS | grep
'^\*.* $(VERSION_REGEXP) ('$$today')' \
527 echo
"version or today's date is not in NEWS" 1>&2; \
531 sc_makefile_TAB_only_indentation
:
532 @grep
-nE
'^ [ ]{8}' \
533 $$($(VC_LIST_EXCEPT
) | grep
-E
'akefile|\.mk$$') \
534 && { echo
'$(ME): found TAB-8-space indentation' 1>&2; \
538 @grep
-nE
'(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
539 $$($(VC_LIST_EXCEPT
) | grep
-E
'(^configure\.ac|\.m4)$$') \
540 && { echo
'$(ME): quote the first arg to AC_DEF*' 1>&2; \
544 'you have changed the set of files with translatable diagnostics;\n\
545 apply the above patch\n'
547 # Verify that all source files using _() are listed in po/POTFILES.in.
548 po_file
= po
/POTFILES.in
550 @if
test -f
$(po_file
); then \
551 grep
-E
-v
'^(#|$$)' $(po_file
) \
552 | grep
-v
'^src/false\.c$$' |
sort > $@
-1; \
554 for file in
$$($(VC_LIST_EXCEPT
)) lib
/*.
[ch
]; do \
555 test -r
$$file || continue
; \
557 *.m4|
*.mk
) continue
;; \
563 base
=`expr " $$file" : ' \(.*\)\..'`; \
564 { test -f
$$base.l ||
test -f
$$base.y
; } && continue
;; \
566 files
="$$files $$file"; \
568 grep
-E
-l
'\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
570 diff
-u
-L
$(po_file
) -L
$(po_file
) $@
-1 $@
-2 \
571 ||
{ printf
'$(ME): '$(fix_po_file_diag
) 1>&2; exit
1; }; \
575 # Sometimes it is useful to change the PATH environment variable
576 # in Makefiles. When doing so, it's better not to use the Unix-centric
577 # path separator of `:', but rather the automake-provided `$(PATH_SEPARATOR)'.
578 msg
= '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead'
579 sc_makefile_path_separator_check
:
580 @grep
-nE
'PATH[=].*:' \
581 $$($(VC_LIST_EXCEPT
) | grep
-E
'akefile|\.mk$$') \
582 && { echo
$(msg
) 1>&2; exit
1; } ||
:
584 # Check that `make alpha' will not fail at the end of the process.
586 if
test -d
$(release_archive_dir
); then
:; else \
587 for file in
$(distdir
).
tar.gz \
588 $(release_archive_dir
)/$(distdir
).
tar.gz
; do \
589 test -e
$$file || continue
; \
591 ||
{ echo ERROR
: $$file is not writable
; fail
=1; }; \
593 test "$$fail" && exit
1 ||
: ; \
596 v_etc_file
= lib
/version-etc.c
597 sample-test
= tests
/sample-test
598 texi
= doc
/$(PACKAGE
).texi
599 # Make sure that the copyright date in $(v_etc_file) is up to date.
600 # Do the same for the $(sample-test) and the main doc/.texi file.
602 @if
test -f
$(v_etc_file
); then \
603 grep
'enum { COPYRIGHT_YEAR = '$$(date
+%Y
)' };' $(v_etc_file
) \
605 ||
{ echo
'out of date copyright in $(v_etc_file); update it' 1>&2; \
608 @if
test -f
$(sample-test
); then \
609 grep
'# Copyright (C) '$$(date
+%Y
)' Free' $(sample-test
) \
611 ||
{ echo
'out of date copyright in $(sample-test); update it' 1>&2; \
614 @if
test -f
$(texi
); then \
615 grep
'Copyright @copyright{} .*'$$(date
+%Y
)' Free' $(texi
) \
617 ||
{ echo
'out of date copyright in $(texi); update it' 1>&2; \
622 (unset CDPATH
; cd
$(srcdir) && $(VC
) diff
) > vc-diffs ||
:
623 if
test -s vc-diffs
; then \
625 echo
"Some files are locally modified:" 1>&2; \
631 # Use this to make sure we don't run these programs when building
632 # from a virgin tgz file, below.
633 null_AM_MAKEFLAGS
= \
640 built_programs
= $$(cd src
&& MAKEFLAGS
= $(MAKE
) -s built_programs.list
)
642 rel-files
= $(DIST_ARCHIVES
)
644 gnulib_dir ?
= $(srcdir)/gnulib
645 gnulib-version
= $$(cd
$(gnulib_dir
) && git describe
)
646 bootstrap-tools ?
= autoconf
,automake
,gnulib
648 announcement
: NEWS ChangeLog
$(rel-files
)
649 @
$(build_aux
)/announce-gen \
650 --release-type
=$(RELEASE_TYPE
) \
651 --package
=$(PACKAGE
) \
652 --prev
=$(PREV_VERSION
) \
654 --gpg-key-id
=$(gpg_key_ID
) \
656 --bootstrap-tools
=$(bootstrap-tools
) \
657 --gnulib-version
=$(gnulib-version
) \
658 --no-print-checksums \
659 $(addprefix --url-dir
=, $(url_dir_list
))
661 ## ---------------- ##
662 ## Updating files. ##
663 ## ---------------- ##
665 ftp-gnu
= ftp
://ftp.gnu.org
/gnu
666 www-gnu
= http
://www.gnu.org
668 emit_upload_commands
:
669 @echo
=====================================
670 @echo
=====================================
671 @echo
"$(build_aux)/gnupload $(GNUPLOADFLAGS) \\"
672 @echo
" --to $(gnu_rel_host):$(PACKAGE) \\"
673 @echo
" $(rel-files)"
674 @echo
'# send the /tmp/announcement e-mail'
675 @echo
=====================================
676 @echo
=====================================
678 noteworthy
= * Noteworthy changes in release ?.?
(????
-??
-??
) [?
]
679 define emit-commit-log
680 printf
'%s\n' 'post-release administrivia' '' \
681 '* NEWS: Add header line for next release.' \
682 '* .prev-version: Record previous version.' \
683 '* cfg.mk (old_NEWS_hash): Auto-update.'
686 .PHONY
: no-submodule-changes
687 no-submodule-changes
:
688 if
test -d
$(srcdir)/.git
; then \
689 diff
=$$(cd
$(srcdir) && git submodule
-q
foreach \
690 git diff-index
--name-only HEAD
) \
692 case
$$diff in
'') ;; \
693 *) echo
'$(ME): submodule files are locally modified:'; \
694 echo
"$$diff"; exit
1;; esac
; \
699 .PHONY
: alpha beta major
700 ALL_RECURSIVE_TARGETS
+= alpha beta major
701 alpha beta major
: $(local-check
) writable-files no-submodule-changes
703 && { echo
$(VERSION
) | grep
-E
'^[0-9]+(\.[0-9]+)+$$' \
704 ||
{ echo
"invalid version string: $(VERSION)" 1>&2; exit
1;};}\
706 $(MAKE
) vc-diff-check
707 $(MAKE
) news-date-check
709 $(MAKE
) dist XZ_OPT
=-9ev
710 $(MAKE
) -s announcement RELEASE_TYPE
=$@
> /tmp
/announce-
$(my_distdir
)
711 if
test -d
$(release_archive_dir
); then \
712 ln
$(rel-files
) $(release_archive_dir
); \
713 chmod a-w
$(rel-files
); \
715 $(MAKE
) -s emit_upload_commands RELEASE_TYPE
=$@
716 echo
$(VERSION
) > $(prev_version_file
)
717 $(MAKE
) update-NEWS-hash
718 perl
-pi
-e
'$$. == 3 and print "$(noteworthy)\n\n\n"' NEWS
719 $(emit-commit-log
) > .ci-msg
720 $(VC
) commit
-F .ci-msg
-a
724 @
test -z
"$(manual_title)" \
725 && { echo
define manual_title in cfg.mk
1>&2; exit
1; } ||
:
726 @cd
'$(srcdir)/doc'; \
727 $(SHELL
) ..
/build-aux
/gendocs.sh
-o
'$(abs_builddir)/doc/manual' \
728 --email
$(PACKAGE_BUGREPORT
) $(PACKAGE
) \
729 "$(PACKAGE_NAME) - $(manual_title)"
730 @echo
" *** Upload the doc/manual directory to web-cvs."
735 $(MAKE
) $(AM_MAKEFLAGS
) clean
736 lcov
--directory .
--zerocounters
738 COVERAGE_CCOPTS ?
= "-g --coverage"
739 COVERAGE_OUT ?
= doc
/coverage
742 $(MAKE
) $(AM_MAKEFLAGS
) CFLAGS
=$(COVERAGE_CCOPTS
) CXXFLAGS
=$(COVERAGE_CCOPTS
)
743 $(MAKE
) $(AM_MAKEFLAGS
) CFLAGS
=$(COVERAGE_CCOPTS
) CXXFLAGS
=$(COVERAGE_CCOPTS
) check
744 mkdir
-p
$(COVERAGE_OUT
)
745 lcov
--directory .
--output-file
$(COVERAGE_OUT
)/$(PACKAGE
).
info \
749 genhtml
--output-directory
$(COVERAGE_OUT
) \
750 $(COVERAGE_OUT
)/$(PACKAGE
).
info \
751 --highlight
--frames
--legend \
752 --title
"$(PACKAGE_NAME)"
754 coverage
: init-coverage build-coverage gen-coverage
756 # Update gettext files.
757 PACKAGE ?
= $(shell basename $(PWD
))
758 PO_DOMAIN ?
= $(PACKAGE
)
759 POURL
= http
://translationproject.org
/latest
/$(PO_DOMAIN
)/
762 rm -f
$(PODIR
)/*.po
&& \
763 echo
"$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
764 wget
--no-verbose
--directory-prefix
$(PODIR
) --no-directories
--recursive
--level
1 --accept .po
--accept .po
.1 $(POURL
) && \
765 echo
'en@boldquot' > $(PODIR
)/LINGUAS
&& \
766 echo
'en@quot' >> $(PODIR
)/LINGUAS
&& \
767 ls
$(PODIR
)/*.po | sed
's/\.po//' | sed
's,$(PODIR)/,,' |
sort >> $(PODIR
)/LINGUAS
769 INDENT_SOURCES ?
= $(C_SOURCES
)
772 indent
$(INDENT_SOURCES
)
774 # If you want to set UPDATE_COPYRIGHT_* environment variables,
775 # put the assignments in this variable.
776 update-copyright-env ?
=
778 # Run this rule once per year (usually early in January)
779 # to update all FSF copyright year lists in your project.
780 # If you have an additional project-specific rule,
781 # add it in cfg.mk along with a line 'update-copyright: prereq'.
782 # By default, exclude all variants of COPYING; you can also
783 # add exemptions (such as ChangeLog..* for rotated change logs)
784 # in the file .x-update-copyright.
785 .PHONY
: update-copyright
787 grep
-l
-w Copyright \
788 $$(export VC_LIST_EXCEPT_DEFAULT
=COPYING
&& $(VC_LIST_EXCEPT
)) \
789 |
$(update-copyright-env
) xargs
$(build_aux
)/$@